--[[----------------------------------------------------------------------------

WFCatExportQueue.lua

--------------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2015 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remains the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and are protected by all applicable
intellectual property laws, including trade secret and copyright laws.
Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

----------------------------------------------------------------------------]]--

	-- RxLua
local Rx = require 'Rx'

	-- WF.core.utils
local WFArguments = require 'WFArguments'
local WFRequestQueue = require 'WFRequestQueue'


--------------------------------------------------------------------------------

local check = assert( WFArguments.check )

--============================================================================--

-- @mark WFCatExportQueue class

--------------------------------------------------------------------------------
--[[!
	\brief WFCatExportQueue maintains a list 
	of export requests.
]]--

local WFCatExportQueue = {

	WFRequestQueue,
		-- Base class

}

--------------------------------------------------------------------------------

function WFCatExportQueue:__init()

	check( 'WFCatExportQueue' )

end

--------------------------------------------------------------------------------

function WFCatExportQueue:dispose()

	check( 'WFCatExportQueue' )

	return self:WFRequestQueue_dispose()

end

--------------------------------------------------------------------------------
--[[!
	\brief Adds a request to the export queue

	\param request table which has the following keys
		id - Id of the asset to be exported
		settings - export settings

]]--

function WFCatExportQueue:addToQueue( request )

	check( 'WFCatExportQueue', 'table' )

	return self:WFRequestQueue_addToQueue( request )

end

--============================================================================--

return Rx.Class 'WFCatExportQueue'( WFCatExportQueue )
